/*
   :
iCustom(string symbol, int timeframe, "_StDevFBA_NR", int ma_period, int ma_shift, 
int ma_method, int applied_price, double FrontPeriod, double BackPeriod,int Sens, int shift)

iCustom(NULL,0,"_StDevFBA_NR",StDperiod,StDshift,StDmethod,PriceField,FrontPeriod,BackPeriod,int Sens, 0,i); // .
iCustom(NULL,0,"_StDevFBA_NR",StDperiod,StDshift,StDmethod,PriceField,FrontPeriod,BackPeriod,int Sens, 1,i); // 
*/
#property indicator_separate_window 
#property indicator_buffers 2
#property indicator_color1 Green //  
#property indicator_color2 Red // 
#property indicator_minimum 0

//  
   //  
extern int StDperiod=20; //  .
extern int StDshift=0; // 
extern int StDmethod=0; //  
extern int PriceField=0; //  
   // 
extern double FrontPeriod=1; //   ; .. <1
extern double BackPeriod=55; //   ; .. <1
   // 
extern int Sens=0; //    .

 int History=0; // - ; 0 -  

// .
double   StD[], //  
         EMA[]; // 

//  
bool first=1; //   
double per0,per1; // - EMA
int FBA=0; // 1 -  , -1 -  , 0 -  MA -  !
double sens; //    

int init()
  {
   //  
   int fdg,bdg;
   if(FrontPeriod<1) fdg=2; if(BackPeriod<1) bdg=2;
   string _fr=DoubleToStr(FrontPeriod,fdg);
   string _bk=DoubleToStr(BackPeriod,bdg);
   if(Sens>0) string ShortName=Sens+" ";
   ShortName=ShortName+"StDev"+_Price(PriceField)+"("+StDperiod+")";
   if(StDshift>0) ShortName=ShortName+"+"+StDshift;
   if(FrontPeriod!=1 || BackPeriod!=1) {
      if(FrontPeriod==BackPeriod) ShortName=ShortName+" ("+_fr+")";
      else {
         if(FrontPeriod!=1) ShortName=ShortName+" Front("+_fr+")";
         if(BackPeriod!=1)  ShortName=ShortName+" Back(" +_bk+")";
        }
     }
   IndicatorShortName(ShortName); 

   first=1;
   sens=Sens*Point; //    

   if(FrontPeriod>1) FrontPeriod=2.0/(1+FrontPeriod); // .  EMA
   if(BackPeriod>1) BackPeriod=2.0/(1+BackPeriod); // .  EMA
   while(true) {
      if(FrontPeriod==BackPeriod) {
         per0=FrontPeriod; per1=1; break;
        }
      if(FrontPeriod>BackPeriod) {
         FBA=-1; per0=FrontPeriod; per1=BackPeriod;
        }
      else {
         FBA= 1; per0=BackPeriod; per1=FrontPeriod;
        }
      break;
     }

   // .    
   //  
   SetIndexBuffer(0,StD);
   SetIndexStyle(0,DRAW_LINE,0);
   SetIndexLabel(0,"StDev("+StDperiod+")");
   // 
   SetIndexBuffer(1,EMA);
   SetIndexStyle(1,DRAW_LINE,0);
   SetIndexLabel(1,"EMA("+_fr+","+_bk+")");

   //  
   SetLevelValue(0,sens);

   return(0);
  }


int reinit() // -  
  {
   ArrayInitialize(StD,0.0);
   ArrayInitialize(EMA,0.0);

   return(0);
  }

int start()
  {
   int ic=IndicatorCounted();
//   if(!first && Bars-ic-1>1) ic=reinit(); 
//   int limit=Bars-ic-1; // - 
//   if(History!=0 && limit>History) limit=History-1; // -   

   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=2;

   for(int i=limit; i>=0; i--) { //     
      bool reset=i==limit && ic==0; //      

      if(reset) {static double MA0prev=0; static int BarsPrev=0;}
      
      //  
      double st=iStdDev(NULL,0,StDperiod,StDshift,StDmethod,PriceField, i); 
      st=MathMax(st,sens); //   
      StD[i]=st;

      //  
      double MA0=EMA_FBA(st,MA0prev,per0,0,i);
      
      //   ()
      EMA[i]=EMA_FBA(MA0,EMA[i+1],per1,FBA,i); 
      
      // 
      if(first || BarsPrev!=Bars) {BarsPrev=Bars; MA0prev=MA0;}

     }   

   first=0; //    
   return(0);
  }

// EMA        
double EMA_FBA(double C, double MA1, double period, int FBA, int i) {
   if(period==1) return(C);
   // . EMA 
   if(period>1) period=2.0/(1+period); 
   // EMA
   double ma=period*C+(1-period)*MA1; 
   //    
   switch(FBA) {
      case  0: //  MA
         if(FBA==0) return(ma); 
      case  1: //  
         if(C>MA1) return(ma); else return(C); 
      case -1: //  
         if(C<MA1) return(ma); else return(C); 
     }
  }

string _Price(int ApplPrice) {
   switch(ApplPrice) {
      case 0: return(""); // Close
      case 1: return("O"); // Open
      case 2: return("H"); // High
      case 3: return("L"); // Low
      case 4: return("M"); // Middle
      case 5: return("T"); // Typical
      case 6: return("W"); // Weighted
      default: return(""); // Close
     }
  }

